#ifndef lint
static char Sccsid[] = "@(#)maint.c	3.4    DeltaDate 11/25/01    ExtrDate 12/10/01";
#endif

/*      MAINT.C         */
/*      This module is displays the maintenance menu and
        controls the execution of the associated routines
*/
#include "stdio.h"
#include "cardfile.h"

char    *mfuncts[]   = {"RTN TO MAIN ",
                        "DUMP        ",
                        "COMPRESS    ",
                        "REBUILD AK's",
                        "EXTRACT     ",
                        0
                        };
#define DUMP    1
#define COMPRES 2
#define RBUILD  3
#define EXTRACT 4
#define EXIT    0


void
maint(struct Fdata *fields, char *dbname, struct AKdata *ak_data)
{
    char        first[SWIDTH];
    int         func;
    
    sprintf(first, "Maintenance functions for %s", dbname);
    while ((func = menu(first, mfuncts)) != EXIT) {
        switch (func) {
        case DUMP:
            dumpdb(dbname, ak_data, fields);
            continue;
        case COMPRES:
            compress(dbname);
            rbuildak(dbname, ak_data, fields);
            continue;
        case RBUILD:
            rbuildak(dbname, ak_data, fields);
            continue;
        case EXTRACT:
            extract(fields, dbname);
            continue;
        default:
            msg("Illegal function chosen");
        }
    }
}

