#ifndef lint
static char Sccsid[] = "@(#)menu.c	3.3    DeltaDate 11/25/01    ExtrDate 12/10/01";
#endif

/*	MENU.C		*/
/*	This subroutine is used to display a menu of commands
**	and wait for the user to select one.
**	It returns the number of the command selected.
**/
#include <stdio.h>
#include "cardfile.h"

int
menu(char *dbname, char **functs)
{
    int         func;
    char        dummy[2];
    struct      Sdata   *sp, *mscreen;
    char	*malloc();

    mscreen = (struct Sdata*)malloc((MAXFLDS+1) * sizeof(struct Sdata));
    sp = mscreen;
    do {
        sp->S_title = *functs;
        sp->S_length = 1;
        sp->S_result = dummy;
        sp->S_dfault = 0;
	sp->S_page = -1;
	sp->S_Lrow = -1;
	sp->S_Lcol = -1;
	sp->S_Drow = -1;
	sp->S_Dcol = -1;
	sp->S_Dfmt = "";
        ++sp;
    } while (*++functs);
    sp->S_title = 0;
    screen(dbname, mscreen, 0, &func, FALSE, 0);
    free((char*)mscreen);
    return (func);
}

